<template>
  <div id="tileSelector">
    <div class="imagesList">
      <img
        v-for="image in images"
        :key="image.key"
        :src="image.path"
        :class="
          'image' +
          (selectedTile === image.number ? ' selected' : '') +
          (disabled ? ' disabled' : ' able')
        "
        @click="$emit('selectedTile', image.number)"
        @mouseover="selectedTileCoordinates = image.coordinates"
      />
    </div>
    <div id="selectedTileInfo">
      [{{ selectedTileCoordinates.x }}, {{ selectedTileCoordinates.y }}]
      {{ selectedTileCoordinates.y * 12 + selectedTileCoordinates.x }}
      {{ selectedTile }}
    </div>
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue, Prop } from "vue-property-decorator";

interface Image {
  key: string;
  number: number;
  coordinates: { x: number; y: number };
  path: string;
}

@Component
export default class TileSelector extends Vue {
  readonly imagesPerRows = 12;
  images: Image[] = [];
  selectedTileCoordinates: { x: number; y: number } = { x: 0, y: 0 };

  @Prop() selectedTile!: number;
  @Prop({ default: false }) disabled!: boolean;

  keyToNumber(key: string): number {
    // "./10.png"
    return parseInt(key.split(".")[1].slice(1));
  }

  created(): void {
    const images = require.context("../../../assets/images/tiles", false, /\.png$/);

    images.keys().forEach((key) => {
      const imageNumber = this.keyToNumber(key);
      this.images.push({
        key,
        number: imageNumber,
        coordinates: {
          x: imageNumber % this.imagesPerRows,
          y: Math.floor(imageNumber / this.imagesPerRows)
        },
        path: images(key)
      });
    });

    // Sort image by number
    this.images.sort((a, b) => a.number - b.number);
  }
}
</script>

<style scoped>
#tileSelector {
  height: 100%;
}
.imagesList {
  height: 100%;
  display: grid;
  grid-template-columns: repeat(12, 1fr);
  overflow-y: auto;
  overflow-x: hidden;
  background-color: black;
}

.image {
  width: 100%;
  color: black;
  border-left: solid rgba(114, 114, 114, 0.493) 1px;
  border-bottom: solid rgba(114, 114, 114, 0.493) 1px;
  image-rendering: -moz-crisp-edges;
  image-rendering: -webkit-crisp-edges;
  image-rendering: pixelated;
  image-rendering: crisp-edges;
}
.image.able:hover {
  cursor: pointer;
  outline: 3px solid white ;
  z-index: 1;
}
.image.able.selected {
  outline: 3px solid rgb(55, 148, 255);
  z-index: 1;
}
.image.disabled {
  cursor: not-allowed;
  opacity: 0.5;
}
#selectedTileInfo {
  position: absolute;
  translate: 5px -30px;
  font-size: 0.8em;
  color: rgba(255, 255, 255, 0.37);
}
</style>
